﻿##### Scriptinfo ##################################################################################
# Scriptreihe	    PAM-AdminGUI\ISETester
# Datum:            2020-02-29
# Version:          V1.10
# Programmierer:    Stephan Walther
###################################################################################################

# Variablen
    $PAMServer = 'WS-DC1.ws.its'
    $PAMRolle  = 'PAM-AdminGUI'

    $PAMAdminGruppe = 'Domain Admins'
    $PAMAdminUser   = 'admin-setup'

# teste 1:1 Remoting
    Enter-PSSession -ComputerName $PAMServer -ConfigurationName $PAMRolle

        liste-Admins
        liste-Gruppen
        liste-Zeitspannen
        liste-DomainController

        # Variablen durchreichen?
            zeige-GruppenMitglieder -Gruppe $PAMAdminGruppe

            erstelle-PAMGruppenMitglied -Admin $PAMAdminUser -Gruppe $PAMAdminGruppe -Zeitspanne '15'
            entferne-PAMGruppenMitglied -Admin $PAMAdminUser -Gruppe $PAMAdminGruppe
        
    Exit-PSSession

# teste Script-Remoting
    # Aufbau der Session
        $JEASession = New-PSSession -ComputerName $PAMServer -ConfigurationName $PAMRolle

    # Aufruf eines List-Befehles:
        Invoke-Command -Session $JEASession -ScriptBlock { liste-Zeitspannen }
    
    # Erstellen einer temporären Gruppenmitgliedschaft mit Variablenweitergabe    
        Invoke-Command -Session $JEASession -ScriptBlock {
            param($PAMAdminUser,$PAMAdminGruppe)

            erstelle-PAMGruppenMitglied -Admin $PAMAdminUser -Gruppe $PAMAdminGruppe -Zeitspanne 10
        } -ArgumentList $PAMAdminUser,$PAMAdminGruppe

    # Abfrage von Gruppenmitgliedern einer bestimmten Gruppe
        Invoke-Command -Session $JEASession -ScriptBlock {
            param($PAMAdminGruppe)

            zeige-GruppenMitglieder -Gruppe $PAMAdminGruppe
        } -ArgumentList $PAMAdminGruppe | Format-Table

    # starten einer AD-Replikation
        Invoke-Command -Session $JEASession -ScriptBlock { 
            param($Gruppe,$DCServer) 
            repliziere-ADChanges -Gruppe $Gruppe -DCServer $DCServer

        } -ArgumentList 'Domain Admins','C-DC2'

    # Entfernen aller temporären Mitgliedschaften
        Invoke-Command -Session $JEASession -ScriptBlock {
            entferne-Mitgliedschaften -admin 'Stephan-T1'
        }

    # Abbauen einer Session
        Get-PSSession | Remove-PSSession